#!/bin/sh
# the next line restarts using tclsh \
	exec tclsh "$0" "$@"

# chat client - connects to port 9988 

proc makecmd { nick cmd msg } {    
    return [list nick $nick cmd $cmd msg $msg]
}

proc chat { cmd args } {
    global nick sk
    switch -exact $cmd {
	nick {
	    set nick [lindex $args 0]
	    puts $sk [makecmd $nick nick ""]
	}
	quit {
	    puts $sk [makecmd $nick quit ""]
	}
	default {
	    puts $sk [makecmd $nick msg $cmd]
	}
    }
}

proc readchat { chan } {
    if { ! [ eof $chan ] } {
	gets $chan data
	puts "$data"
    } else {
	exit 1
    }
}

proc main { argv0 argv } {
    global nick sk
    set nick [lindex $argv 0]
    if { $nick == "" } {
	puts stderr "Usage: $argv0 nick"
	exit 1
    }
    set port 9988
    set sk [socket localhost $port]
    fconfigure $sk -buffering line
    fileevent $sk readable [list readchat $sk]
    puts $sk [makecmd $nick join ""]
}

main $argv0 $argv

package require tclreadline
tclreadline::Loop
