'\"
'\" Copyright (c) 2001 by David N. Welton <davidw@dedasys.com>.
'\" All rights reserved.
'\" 
'\" $Id$
'\" 
.TH multiplexer n 0.1 MULTIPLEXER "Tcl Multiplexer Server"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
::multiplexer \- Create multiplexer (one to many comunication) server.
.SH SYNOPSIS
\fB
.CS
 package require multiplexer ?0.1?

 multiplexer::Init \fIport\fR

.CE
.sp
.BE
.SH DESCRIPTION
.PP
The \fB::multiplexer::Init\fR command creates a new server socket that
is capable of doing one-to-many comunication.  

.SH COMMANDS
.PP
.TP
\fB::multiplexer::AddAccessFilter\fR \fIAccessFilter\fR
Command to add an access filter that will be called like so:

AccessFilter chan clientaddress clientport

Arguments: 

function: proc to filter access to the multiplexer.  Takes chan,
clientaddress and clientport arguments.  Returns 0 on success, -1 on
failure.
.TP
\fB::multiplexer::AddFilter\fR \fIFilter\fR
Command to add a filter for data that passes through the
multiplexer.  The filter proc is called like this:

Filter data chan clientaddress clientport

Arguments:

function: proc to filter data that arrives to the multiplexer.  Takes
data, chan, clientaddress, and clientport arguments.  Returns filtered
version of data.
.TP
\fB::multiplexer::AddExitFilter\fR \fIExitFilter\fR
Adds filter to be run when client socket generates an EOF condition.
ExitFilter functions look like the following:

ExitFilter chan clientaddress clientport

Arguments:

function: hook to be run when clients exit by generating an EOF.
Takes chan, clientaddress and clientport arguments, and returns
nothing.
.TP
\fB::multiplexer::Config\fR \fIkey\fR \fIvalue\fR

Configure global options, which currently include the following:

\fIsendtoorigin\fR: if 1, resend the data to all clients, including the
sender.  Defaults to 0

\fIbuffering\fR: fed to Tcl's fconfigure -buffering.  Defaults to line.

\fIdebug\fR: if greater than 0, prints additional debug messages.
Defaults to 0

Arguments:

key: name of option to configure

value: value for option.
.TP
\fB::multiplexer::Init\fR \fIport\fR

Start the server on the specified port.

.SH KEYWORDS
multiplexer server

.SH BUGS
Currently only handles one multiplexer server at a time
