#!/bin/sh
# the next line restarts using tclsh \
	exec tclsh "$0" "$@"

source [file join . multiplexer.tcl]

proc AccessFilter { chan client clientport } {
    global state connected banlist
    if { [lsearch $banlist $client] != -1 } {
	puts $chan "ACCESS DENIED - you are banished!"
	flush $chan
	return -1
    }
    puts $chan "Welcome to the Tcl'ers Chat!"
    flush $chan
    return 0
}

# commands take the form

# {nick $nick} {cmd $cmd} {msg $msg}

proc Filter { data chan client clientport } {
    global state connected
    array set line $data
    switch -exact $line(cmd) {
	quit {
	    multiplexer::DelClient $chan $client $clientport
	    set connected($line(nick)) 0
	    return $line(msg)
	}
	join {
	    set connected($line(nick)) 1
	    if { [info exists state($line(nick))] } {
		puts $chan [join $state($line(nick))]
		set state($line(nick)) ""
	    } else {
		puts $chan "no new messages"
	    }
	    return "$line(nick) joined"
	}
	msg {
	    # store data for those who are not connected
	    foreach cl [array names connected] {
		if { $connected($cl) != 1 } {
		    lappend state($cl) "$line(nick) says: $line(msg)"
		}
	    }
	    return "$line(nick) says: $line(msg)"
	}
    }
    return "ERROR, data is: $data"
}

proc ExitFilter { chan client clientport } {
    global connected
    puts "Client from ${client} : $clientport using Tcl channel $chan has left"
}

set banlist [list]
array set state {}
array set connected {}

multiplexer::AddAccessFilter AccessFilter
multiplexer::AddFilter Filter
multiplexer::AddExitFilter ExitFilter

multiplexer::Config debug 1
multiplexer::Config sendtoorigin 0
multiplexer::Init 9988

vwait forever